﻿using System;

namespace FunctionalCLR.Core {
    public class DegreeToRadian : FuncNode {

        public DegreeToRadian()
            : base() {
            base.Value = "degreeToRadian";
        }

        public override FuncNode GetReversedFunction(int index) {
            throw new NoOppositeOperatorException(string.Format(
                "Function {0} cannot be transformed", this.Value));
        }

        public override object Evaluate() {
            if (Children.Count < 1) {
                throw new ArgumentException("usage: degreeToRadian(radian);");
            }

            double result = Convert.ToDouble(Children[0].Evaluate());

            return result * Math.PI / 180;
        }
    }
}
