﻿using System;
using System.Collections.Generic;
using System.Text;

namespace FunctionalCLR.Core
{
    public class AsinNode : FuncNode
    {
        public AsinNode() : base()
        {
            base.Value = "asin";
            this.ParameterCount = 1;
        }

        public override object Accept(IVisitor visitor)
        {
            return visitor.Visit(this);
        }

        public override FuncNode GetReversedFunction(int index)
        {
            return new SinNode();
        }

        public override object Evaluate()
        {
            double result = Convert.ToDouble(Children[0].Evaluate());

            return Math.Asin(result).ToString();
        }
    }
}
