﻿using System;
using System.Collections.Generic;
using System.Text;
using FunctionalCLR.Core.Function;

namespace FunctionalCLR.Core {
    public class CoshNode : FuncNode {

        public CoshNode()
            : base() {
            base.Value = "cosh";
            this.ParameterCount = 1;
        }

        public override object Accept(IVisitor visitor) {
            return visitor.Visit(this);
        }

        public override FuncNode GetReversedFunction(int index) {
            return new AcoshNode();
        }

        public override object Evaluate() {
            double result = Convert.ToDouble(Children[0].Evaluate());

            return SpecialFunction.cosh(result).ToString();
        }
    }
}
