﻿namespace Zove.Runtime
{
    /// <summary>
    /// Runtime model loader
    /// </summary>
    public interface IRuntimeModelLoader
    {
        /// <summary>
        /// Load by class name
        /// </summary>
        /// <param name="className">class name</param>
        /// <returns>a runtime model</returns>
        RuntimeModel LoadByClassName(string className);

        /// <summary>
        /// Load by the class source
        /// </summary>
        /// <param name="source">the source</param>
        /// <returns>a runtime model</returns>
        RuntimeModel LoadBySource(string source);
    }
}