﻿using EmbeddedSharp.Core;
using Zove.Runtime.Core;

namespace Ascend.Runtime.Core
{
    public class AscendClassParserFactory : IClassParserFactory
    {
        protected ILanguageNature LanguageNature;

        public AscendClassParserFactory(ILanguageNature languageNature)
        {
            LanguageNature = languageNature;
        }

        #region IClassParserFactory Members

        public IClassParser CreateClassParser(ITextContentProvider provider)
        {
            var parser = new AscendClassParser(provider, LanguageNature);

            return parser;
        }

        #endregion
    }
}