﻿using System;

namespace EmbeddedSharp.Core.Function.String {

    /// <summary>
    /// Convert the string to all capital letters.
    /// 
    /// Syntax: UpperCase(expr);
    /// 
    /// Example:
    /// expr = LowerCase("Hello, world!"); # HELLO, WORLD!
    /// echo(expr);
    /// </summary>
    public class LowerCaseNode : FuncNode {

        public LowerCaseNode()
            : base() {
            base.Value = "lowercase";
        }

        public override object Evaluate() {
            if (Parameters.Count < 1) {
                return "usage: lowercase(expr);";
            }

            string expr = Convert.ToString(Parameters[0].Evaluate());
            return expr.ToLower();
        }
    }
}
