﻿using System;
using System.Collections.Generic;
using System.Text;

namespace EmbeddedSharp.Core.Function.Trigonometry {
    public class AcosNode : FuncNode {
        public AcosNode()
            : base() {
            base.Value = "acos";
        }

        public override FuncNode GetReversedFunction(int index) {
            return new CosNode();
        }

        public override object Evaluate() {
            if (Parameters.Count < 1) {
                throw new ArgumentException(
                    "usage: acos(number)");
            }

            double result = Convert.ToDouble(
                Parameters[0].Evaluate());

            return System.Math.Acos(result).ToString();
        }
    }
}
