﻿using System;
using System.Collections.Generic;
using System.Text;

namespace EmbeddedSharp.Core.Function.Trigonometry {
    public class AsinNode : FuncNode {
        public AsinNode()
            : base() {
            base.Value = "asin";
        }

        public override FuncNode GetReversedFunction(int index) {
            return new SinNode();
        }

        public override object Evaluate() {
            if (Parameters.Count < 1) {
                throw new ArgumentException(
                    "usage: asin(number)");
            }

            double result = Convert.ToDouble(Parameters[0].Evaluate());

            return System.Math.Asin(result).ToString();
        }
    }
}
