﻿using System;
using System.Collections.Generic;
using System.Text;
using EmbeddedSharp.Core.Function;

namespace EmbeddedSharp.Core.Function.Trigonometry {
    public class AsinhNode : FuncNode {

        public AsinhNode()
            : base() {
            base.Value = "asinh";
        }

        public override FuncNode GetReversedFunction(int index) {
            return new SinhNode();
        }

        public override object Evaluate() {
            if (Parameters.Count < 1) {
                throw new ArgumentException(
                    "usage: asinh(number)");
            }

            double result = Convert.ToDouble(Parameters[0].Evaluate());

            return SpecialFunction.asinh(result).ToString();
        }
    }
}
