﻿using System;
using System.Collections.Generic;
using System.Text;
using EmbeddedSharp.Core.Function;

namespace EmbeddedSharp.Core.Function.Trigonometry {
    public class AtanhNode : FuncNode {

        public AtanhNode()
            : base() {
            base.Value = "atanh";
        }

        public override FuncNode GetReversedFunction(int index) {
            return new TanhNode();
        }

        public override object Evaluate()
        {
            if (Parameters.Count < 1)
            {
                throw new ArgumentException(
                    "usage: atanh(number)");
            }

            double result = Convert.ToDouble(Parameters[0].Evaluate());

            return SpecialFunction.atanh(result).ToString();
        }
    }
}
