﻿using System;
using System.Collections.Generic;
using System.Text;

namespace EmbeddedSharp.Core.Function.Trigonometry {
    public class CosNode : FuncNode {
        public CosNode()
            : base() {
            base.Value = "cos";
        }

        public override FuncNode GetReversedFunction(int index) {
            return new AcosNode();
        }

        public override object Evaluate() {
            if (Parameters.Count < 1) {
                throw new ArgumentException(
                    "usage: cos(number)");
            }

            double result = Convert.ToDouble(
                Parameters[0].Evaluate());

            return System.Math.Cos(result).ToString();
        }
    }
}
