﻿using System;
using System.Collections.Generic;
using System.Text;
using EmbeddedSharp.Core.Function;

namespace EmbeddedSharp.Core.Function.Trigonometry {
    public class CoshNode : FuncNode {

        public CoshNode()
            : base() {
            base.Value = "cosh";
        }

        public override FuncNode GetReversedFunction(int index) {
            return new AcoshNode();
        }

        public override object Evaluate()
        {
            if (Parameters.Count < 1)
            {
                throw new ArgumentException(
                    "usage: cosh(number)");
            }

            double result = Convert.ToDouble(Parameters[0].Evaluate());

            return SpecialFunction.cosh(result).ToString();
        }
    }
}
