﻿using System;
using System.Collections.Generic;
using System.Text;
using EmbeddedSharp.Core.Function;

namespace EmbeddedSharp.Core.Function.Trigonometry {
    public class SinhNode : FuncNode {

        public SinhNode()
            : base() {
            base.Value = "sinh";
        }

        public override FuncNode GetReversedFunction(int index) {
            return new AsinhNode();
        }

        public override object Evaluate() {
            if (Parameters.Count < 1) {
                throw new ArgumentException(
                    "usage: sinh(number)");
            }

            double result = Convert.ToDouble(Parameters[0].Evaluate());

            return SpecialFunction.sinh(result).ToString();
        }
    }
}
