﻿using System;
using System.Collections.Generic;
using System.Text;

namespace EmbeddedSharp.Core.Function.Trigonometry {
    public class TanNode : FuncNode {
        public TanNode() {
            base.Value = "tan";
        }

        public override FuncNode GetReversedFunction(int index) {
            return new AtanNode();
        }

        public override object Evaluate() {
            if (Parameters.Count < 1) {
                throw new ArgumentException(
                    "usage: tan(number)");
            }

            double result = Convert.ToDouble(
                Parameters[0].Evaluate());

            return System.Math.Tan(result).ToString();
        }
    }
}
