﻿using System;

namespace EmbeddedSharp.Core {

    [AttributeUsage(AttributeTargets.Class | AttributeTargets.Struct)]
    public class FunctionAttribute : Attribute {

        public string Name {
            get;
            set;
        }

        public string Catalog {
            get;
            set;
        }

        public string Description {
            get;
            set;
        }

        public string Sample {
            get;
            set;
        }

        public string ExpectedResult {
            get;
            set;
        }

        public FunctionAttribute(
            string name, string description, 
            string sample, string expectedResult) {
            Name = name;
            Description = description;
            Sample = sample;
            ExpectedResult = expectedResult;
        }
    }
}
