﻿using System.Collections.Generic;

namespace EmbeddedSharp.Core {
    public interface IFunctionManager {

        void Add(string funcName, object func);

        FuncNode GetFunction(string functionName);

        FunctionAttribute GetFunctionAttribute(string functionName);

        Dictionary<string, object> Functions {
            get;
            set;
        }

        bool Exist(string fileName);

        void Remove(string command);

        bool IsUserDefinedFunction(string p);

        IFunctionLoader FunctionLoader {
            get;
        }
    }
}
