﻿using System;
using System.IO;
using EmbeddedSharp.Core;

namespace EmbeddedSharp.Scripting.Function.IO {

    /// <summary>
    /// CreateFile("c:\\hello.txt");
    /// </summary>
    public class CreateFileNode : FuncNode {

        public CreateFileNode()
            : base() {
            base.Value = "create";
        }

        public override object Evaluate() {
            if (Parameters.Count < 1) {
                return "usage: create(fileName)";
            }

            try {
                string fileName = Parameters[0].Evaluate().ToString();
                FileStream fs = File.Create(fileName);
                fs.Close();
                return fileName;
            } catch (Exception ex) {
                return ex.Message;
            }

            return "file cannot be created.";
        }
    }
}
