﻿using EmbeddedSharp.Core;
using System.IO;

namespace EmbeddedSharp.Scripting.Function.IO {

    /// <summary>
    /// buff = "";
    /// filename = "c:\\hello.txt";
    /// if(hasfile(filename), buff = read("c:\\hello.txt"));
    /// echo(buff);
    /// </summary>
    public class ReadNode : FuncNode {

        public ReadNode()
            : base() {
            base.Value = "read";
        }

        public override object Evaluate() {
            if (Parameters.Count < 1) {
                return "usage: read(fileName)";
            }

            object obj = Parameters[0].Evaluate();
            return File.ReadAllText(obj.ToString());
        }
    }
}
