﻿using System;
using System.Collections.Generic;
using System.Text;
using EmbeddedSharp.Core;

namespace EmbeddedSharp.Scripting.Function.List {

    /// <summary>
    /// lst = union([1,2], [2,3], [,5,7]);
    /// echo(lst);
    /// 
    /// the expected result is [1,2,3,5,7]
    /// </summary>
    public class RankNode : FuncNode {

        public RankNode()
            : base() {
            this.Value = "rank";
        }

        public override object Evaluate() {
            foreach (Node child in Parameters) {
                ((ListNode)child).Evaluate();
            }

            List<string> values = new List<string>();
            ListNode result = new ListNode();

            for (int i = 0; i < Parameters.Count; i++) {
                ListNode c = (ListNode)Parameters[i];
                foreach (Node u in c.Parameters) {
                    if (!values.Contains(u.Value)) {
                        result.Parameters.Add(u);
                        values.Add(u.Value);
                    }
                }
            }

            return result;
        }
    }
}
