﻿using System;
using System.Collections.Generic;
using System.Text;
using EmbeddedSharp.Core;

namespace EmbeddedSharp.Scripting.Function.Settings {
    public class GlobalSettingsNode : FuncNode {

        public GlobalSettingsNode()
            : base() {
            base.Value = "GlobalSettings";
        }

        public override object Evaluate() {
            if (Parameters.Count < 1) {
                return new ArgumentException(
                    "Usage: GlobalSettings(settingName);");
            }

            string arg = Convert.ToString(Parameters[0].Evaluate());
            switch (arg) {
                case "UserName":
                    return Environment.UserName;
                case "OSVersion":
                    return Environment.OSVersion;
                case "Version":
                    return Environment.Version;
                case "DomainName":
                    return Environment.UserDomainName;
                case "CurrentDirectory":
                    return Environment.CurrentDirectory;
                case "CommandLine":
                    return Environment.CommandLine;
                case "SystemDirectory":
                    return Environment.SystemDirectory;
                case "ProcessorCount":
                    return Environment.ProcessorCount;
                case "MachineName":
                    return Environment.MachineName;
                default:
                    break;
            }

            return string.Empty;
        }
    }
}
