﻿using System;
using System.Collections.Generic;
using EmbeddedSharp.Core;

namespace EmbeddedSharp.Scripting {
    public interface IDebuggable {

        void StartDebugging();

        void Resume();

        List<BreakPoint> BreakPoints {
            get;
        }

        void Stop();

        void Restart();

        DebuggingState State {
            get;
        }

        IContext Context {
            get;
        }

        void StepInto();

        void StepOver();
    }
}
