﻿using System.Collections.Generic;
using EmbeddedSharp.Core;
using EmbeddedSharp.Scripting;

namespace Zove.Desktop {
    public interface IDebuggableView : IRunnableView {

        void StartDebugging();

        void Resume();

        List<BreakPoint> BreakPoints {
            get;
        }

        void Break();

        void Stop();

        void Restart();

        DebuggingState State {
            get;
        }

        IContext Context {
            get;
        }

        void StepInto();

        void StepOver();
    }
}
