﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Zove.DesignTime;
using System.ComponentModel;

namespace Zove.Desktop {
    public class Model : ZoomClass {

        private ZoomClass zc = null;

        public Model(ZoomClass zc) {
            this.zc = zc;
        }

        [CategoryAttribute("Name"), 
        DescriptionAttribute("Name of the model")]
        public string ModelName {
            get {
                return this.zc.Name;
            }
        }

        [CategoryAttribute("Number of Factors"),
        DescriptionAttribute("Number of Factors")]
        public int NumberOfFactors {
            get {
                return this.zc.Variables.Count;
            }
        }

        [CategoryAttribute("Number of Equations"),
        DescriptionAttribute("Number of Equations")]
        public int NumberOfEquations {
            get {
                return this.zc.Equations.Count;
            }
        }

        [CategoryAttribute("Number of Functions"),
        DescriptionAttribute("Number of Functions")]
        public int NumberOfFunctions {
            get {
                return this.zc.Functions.Count;
            }
        }
    }
}
