﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using RootFinding;

namespace Zove.Desktop {
    public partial class RootFinderForm : Form, IDesktopView {
        public RootFinderForm() {
            InitializeComponent();
        }

        public void Run() {
            if (string.IsNullOrEmpty(this.tbEquation.Text)) {
                return;
            }

            try {
                IRootFinder rootFinder = new SimpleRootFinder();
                double result = rootFinder.Solve(this.tbEquation.Text, 0, double.MaxValue);

                MessageBox.Show(result.ToString());
            } catch (Exception ex) {
                MessageBox.Show(ex.Message);
            }
        }

        #region IDesktopForm Members
        
        public DigitalRune.Windows.TextEditor.TextEditorControl GetTextEditorControl() {
            throw new NotImplementedException();
        }

        public string GetFileName() {
            throw new NotImplementedException();
        }

        public string GetFileExtension() {
            throw new NotImplementedException();
        }

        public void RunInBackground()
        {
        }

        public void Export(string fileName) {
            throw new NotImplementedException();
        }

        public void Save(string fileName) {
            throw new NotImplementedException();
        }

        public string GetFileFilter() {
            throw new NotImplementedException();
        }

        public virtual string GetColourScheme() {
            return string.Empty;
        }

        #endregion

        #region IDesktopForm Members


        public new void Validate()
        {
            throw new NotImplementedException();
        }

        public void Stop()
        {
            throw new NotImplementedException();
        }

        #endregion

        #region IDesktopForm Members


        public void Debug() {
            throw new NotImplementedException();
        }

        public void Resume() {
            throw new NotImplementedException();
        }

        public void Restart() {
            throw new NotImplementedException();
        }

        public double Profile() {
            throw new NotImplementedException();
        }

        #endregion
    }
}
