﻿using System;
using System.Collections.Generic;
using System.Text;
using EmbeddedSharp.Core;
using Zove.Runtime.EmbeddedSharp;

namespace Zove.Scripting.Modelling {

    /// <summary>
    /// Purify the expression
    /// </summary>
    public class FormulateExpressionTranslator : DefaultExpressionTranslator {

        private string sub;

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="subject"></param>
        public FormulateExpressionTranslator(string subject) {
            this.sub = subject;
        }

        /// <summary>
        /// Dealt with the terminal node
        /// </summary>
        /// <param name="node"></param>
        /// <returns></returns>
        protected override string ProcessTerminalNode(Node node) {
            if (node is FactorNode) {
                FactorNode fn = node as FactorNode;
                if (fn.Value != sub) {
                    return fn.Factor.Value.ToString();
                } else {
                    return fn.Value;
                }
            }

            return base.ProcessTerminalNode(node);
        }
    }
}
