﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using CommonModellingRuntime.Ascend;
using Zove.DesignTime;
using Ascend.Tools.ModelIndexer;
using Ascend.Runtime.Core;

namespace Zove.Runtime.Test {
    /// <summary>
    /// Summary description for AscendTests
    /// </summary>
    [TestClass]
    public class AscendTests {
        public AscendTests() {
            //
            // TODO: Add constructor logic here
            //
        }

        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext {
            get {
                return testContextInstance;
            }
            set {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void TestRun() {
            string source = @"MODEL Test
a IS_A factor;
b IS_A factor;

a = b*2;
METHODS
METHOD on_load
END on_load
END Test";

            string source2 = @"MODEL thermalequilibrium;
	T_1 IS_A temperature;
	T_2 IS_A temperature;
	m_1, m_2 IS_A mass;
	C_p IS_A specific_heat_capacity;
	h IS_A heat_transfer_coefficient;
	A IS_A area;

	Q IS_A energy_rate;
	Q = h*A*(T_1 - T_2);
	m_1*C_p*dT1dt = 0-Q;
	m_2*C_p*dT2dt = 0+Q;
	
	dT1dt IS_A temperature_rate;
	dT2dt IS_A temperature_rate;

	t IS_A time;
METHODS
METHOD on_load;
	FIX C_p, h, A, m_1, m_2, T_1, T_2;
	A := 1 {m^2};
	h := 10 {W/m^2/K};
	C_p := 4.2 {kJ/kg/K};
	m_1 := 10 {kg};
	m_2 := 10 {kg};

	T_1 := 500 {K};
	T_2 := 290 {K};

	t.ode_type := 1;

	T_1.ode_id := 1;
	dT1dt.ode_id := 1;
	T_1.ode_type := 1;
	dT1dt.ode_type := 2;

	T_2.ode_id := 2;
	dT2dt.ode_id := 2;
	T_2.ode_type := 1;
	dT2dt.ode_type := 2;

	Q.obs_id := 2;
	T_1.obs_id := 3;
	T_2.obs_id := 4;
	
END on_load;

END thermalequilibrium;";

            AscendClassFinder finder = new AscendClassFinder();
            finder.AddClassPath(@"C:\Users\Administrator\Documents\项目\Zove\Modeling\Ascend Models");
            
            AscendClassLoader loader = new AscendClassLoader();
            loader.ClassFinder = finder;
            AscendLexer lexer = new AscendLexer(source2);
            ZoomClass c = loader.Load(lexer);

            AscendModel model = new AscendModel(source2);

            model.Run();

            Console.WriteLine(c);
        }

        [TestMethod]
        public void TestIndex() {
            AscendClassFinder finder = new AscendClassFinder();

            finder.Scan(@"C:\Users\Administrator\Documents\项目\Zove\Modeling\Ascend Models\ben");

            Console.WriteLine(finder.Index.Count);
            foreach (string model in finder.Index.Keys) {
                Console.WriteLine(model);
            }
        }

        [TestMethod]
        public void TestComment() {
            AscendLexer lexer = new AscendLexer(@"
(* This MODEL deals with the backend and the c3 splitter
 * IN particular. There are only 3 components IN this MODEL.
 *)
   
REQUIRE system;
");

            lexer.NextToken();

            Assert.AreEqual(@"
(* This MODEL deals with the backend and the c3 splitter
 * IN particular. There are only 3 components IN this MODEL.
 *)", lexer.LastComment);
        }
    }
}
