﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Threading;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Zove.Scripting.Core;
using EmbeddedSharp.Core;
using EmbeddedSharp.Scripting;

namespace Zove.Runtime.Test {
    /// <summary>
    /// Summary description for DebugerTest
    /// </summary>
    [TestClass]
    public class DebugerTest {
        public DebugerTest() {
            //
            // TODO: Add constructor logic here
            //
        }

        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext {
            get {
                return testContextInstance;
            }
            set {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        string source = "hello=1;hello=2;hello=3;";

        [TestMethod]
        public void TestBreak() {
            intp.Breaked += new EventHandler<DebuggingEventArgs>(intp_Break);
            intp.IsDebugging = true;
            intp.BreakPoints.Add(new BreakPoint(2));

            Thread thread = new Thread(new ThreadStart(Run));

            thread.Start();
        }

        private ZoveScriptingObject intp = null;

        public void Run() {
            intp = new ZoveScriptingObject(source);
            intp.Run();
        }

        public void intp_Break(object sender, DebuggingEventArgs e) {
            Console.WriteLine("Breaked");

            Assert.AreEqual(2, Convert.ToDouble(intp.Context.GetVariable("hello")));
            intp.Resume();
        }
    }
}
