﻿using System;
using EmbeddedSharp.Scripting;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Zove.Runtime.Test {
    /// <summary>
    /// Summary description for InterfacingTests
    /// </summary>
    [TestClass]
    public class InterfacingTests {
        public InterfacingTests() {
            //
            // TODO: Add constructor logic here
            //
        }

        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext {
            get {
                return testContextInstance;
            }
            set {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void TestConvert() {
            string source = "a=mmaConvert(2+2);";

            ScriptingObject script = new ScriptingObject(source);
            script.Run();

            IContext cntx = script.Context;
            object ret = cntx.GetVariable("a");
            Assert.AreEqual("(2+2)", ret.ToString());
        }

        [TestMethod]
        public void TestEvaluate() {
            string source = "a=mmaEvaluate(2+1);";
            ScriptingObject script = new ScriptingObject(source);
            script.Run();

            IContext cnt = script.Context;
            double var = Convert.ToDouble(cnt.GetVariable("a"));
            Assert.AreEqual(3, var);
        }
    }
}
