﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Zove.Scripting.Core;
using EmbeddedSharp.Scripting;

namespace Zove.Runtime.Test {
    /// <summary>
    /// Summary description for ZoveScriptTests
    /// </summary>
    [TestClass]
    public class ZoveScriptTests {
        public ZoveScriptTests() {
            //
            // TODO: Add constructor logic here
            //
        }

        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext {
            get {
                return testContextInstance;
            }
            set {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void TestSphereCone() {
            IContext context = ZoveScriptingObject.Run(
                @"C:\Program Files\Zove\Models\Applications\Geometry\Optimization\Solid\Sphere\Cone\SphereCone.zapp");

            Assert.AreEqual(250928.632768728, context.GetVariable("vol"));
        }

        [TestMethod]
        public void TestConeSlantArea() {
            IContext context = ZoveScriptingObject.Run(@"C:\Program Files\Zove\Models\Applications\Geometry\Optimization\Solid\Cone\Maximize Cone Volume from Slant Angle\MaxConeVolume.zapp");

            Assert.AreEqual(368.325035844223, context.GetVariable("maxvol"));
        }
    }
}
