﻿using System;

namespace Zove.Runtime.Core {
    
    /// <summary>
    /// 
    /// </summary>
    public class FactorNotDeclaredException : Exception {

        public FactorNotDeclaredException(
            string factorName): base("The factor " + factorName + " is not found.")
        {
        }

        public FactorNotDeclaredException(
            string elementName, string equation, string className)
            : base(string.Format(
            "The variable {0} in equation '{1}' of class {2} is not declared",
            elementName, equation, className)) {
        }

        public FactorNotDeclaredException(
            string elementName, int ln, string className)
            : base(string.Format(
            "The variable {0} used in line {1} of class {2} is not declared",
            elementName, ln, className)) {
        }
    }
}
