﻿using System;
using EmbeddedSharp.Core;

namespace EmbeddedSharp.Scripting.Visualization.Functions {

    /// <summary>
    /// Draw a line.
    /// </summary>
    [Function("Line", "Draw a line", "line([0,0], [1,1])", "")]
    public class LineNode : VisualizationContextFuncNode
    {
        public LineNode()
            : base() {
            base.Value = "line";
        }

        public override object Evaluate() {
            int count = Parameters.Count;
            if (Parameters.Count < 2) {
                throw new Exception("usage: Line([x1, y1], [x2, y2][, title])");
            }

            ListObject lst1 = (ListObject)Parameters[count-1].Evaluate();
            ListObject lst2 = (ListObject)Parameters[count-2].Evaluate();
            
            if(lst1.Count < 2) {
                throw new ArgumentException("Coordinator is wrong.");
            } else if(lst2.Count < 2) {
                throw new ArgumentException("Coordinator is wrong.");
            }

            double x = Convert.ToInt32(lst1[1]);
            double y = Convert.ToInt32(lst1[0]);
            Point2D s = new Point2D(x, y);

            x = Convert.ToInt32(lst2[0]);
            y = Convert.ToInt32(lst2[0]);
            Point2D e = new Point2D(x, y);

            Provider.AddLine(s, e);

            return string.Empty;
        }
    }
}
