﻿using EmbeddedSharp.Core;

namespace EmbeddedSharp.Scripting.Optimization {

    /// <summary>
    /// The form is 
    /// a = minimize(1-2*x^2, [x], 0, 100);
    /// echo(a); # the result is 
    /// echo(x); # the output is
    /// </summary>
    [Function("minimize", "Minimize a given function", "a=minimize(1-2*x^2, [x], 0, 100);", "a==")]
    public class MinimizeNode : OptimizeNode {

        public MinimizeNode()
            : base(false) {
            base.Value = "minimize";
        }
    }
}
